package org.openntf.domino.nsfdata.structs.cd;

import org.openntf.domino.nsfdata.structs.SIG;
import org.openntf.domino.nsfdata.structs.WSIG;

/**
 * Text in a rich-text field can have the "Pass-Thru HTML" attribute. Pass-through HTML text is not translated to the Domino rich text
 * format. Pass-through HTML text is marked by CDHTMLBEGIN and CDHTMLEND records. (editods.h)
 * 
 * @since Lotus Notes/Domino 4.6
 *
 */
public class CDHTMLBEGIN extends CDRecord {

	public final WSIG Header = inner(new WSIG());
	public final Unsigned8[] Spares = array(new Unsigned8[4]);

	@Override
	public SIG getHeader() {
		return Header;
	}

}
